package info.xiancloud.qclouddocker.api.unit.service;

import info.xiancloud.plugin.Input;
import info.xiancloud.plugin.message.UnitResponse;
import info.xiancloud.plugin.UnitMeta;
import info.xiancloud.plugin.message.UnitRequest;
import info.xiancloud.qclouddocker.api.unit.QCloudBaseUnit;

/**
 * 暂停服务更新接口
 *
 * @author yyq
 */
public class PauseClusterServiceUnit extends QCloudBaseUnit {
    @Override
    public String getName() {
        return "pauseClusterService";
    }

    @Override
    public UnitMeta getMeta() {
        return UnitMeta.create("暂停服务更新(用于暂停升级中的服务，当服务未在升级中，使用暂停功能也会停止容器的扩缩容，后续的更新服务操作也不会启动)");
    }

    @Override
    public Input getInput() {
        return new Input()
                .add("clusterId", String.class, "集群ID，可通过查询集群接口反回字段中的 clusterId获取", REQUIRED)
                .add("serviceName", String.class, "服务名", REQUIRED)
                .add("namespace", String.class, "命名空间,默认为default");
    }

    @Override
    public UnitResponse execute(UnitRequest msg) {
        return super.execute(msg);
    }

    @Override
    public String getAction() {
        return "PauseClusterService";
    }

    @Override
    public String getAPIHost() {
        return "ccs.api.qcloud.com";
    }

}
